/**
 * @license
 * Copyright 2023 Tyler Technologies, Inc. 
 * License: Apache-2.0
 */
import { BaseAdapter, IBaseAdapter } from '../core/base/base-adapter';
import { IDialogComponent } from './dialog';
import { DialogPositionType } from './dialog-constants';
export interface IDialogAdapter extends IBaseAdapter {
    initializeAccessibility(): void;
    setAnimating(animating: boolean): void;
    setVisibility(visible: boolean): void;
    attach(): void;
    detach(): void;
    setDocumentListener(type: string, listener: (evt: Event) => void): void;
    removeDocumentListener(type: string, listener: (evt: Event) => void): void;
    registerTransitionEndHandler: (handler: (evt: TransitionEvent) => void) => void;
    deregisterTransitionEndHandler: (handler: (evt: TransitionEvent) => void) => void;
    registerBackdropClickHandler: (handler: (evt: CustomEvent) => void) => void;
    deregisterBackdropClickHandler: (handler: (evt: CustomEvent) => void) => void;
    getOpenDialogs: (selector: string) => NodeListOf<HTMLElement>;
    setBodyAttribute: (name: string, value: string) => void;
    removeBodyAttribute: (name: string) => void;
    trySetInitialFocus: () => void;
    isScrollable(): boolean;
    addRootClass(name: string): void;
    setFullscreen(value: boolean): void;
    setMoveable(value: boolean): void;
    tryLayoutRippleChildren(): void;
    setMoveTarget(selector: string): boolean;
    setMoveTargetHandler(type: string, listener: (evt: MouseEvent) => void): void;
    removeDragTargetHandler(type: string, listener: (evt: MouseEvent) => void): void;
    getSurfaceBounds(): DOMRect;
    setSurfacePosition(x: string | null, y: string | null, positionType: DialogPositionType): void;
    captureActiveElement(): void;
    tryRestoreActiveElement(): void;
}
/**
 * Provides facilities for interacting with the internal DOM of `DialogComponent`.
 */
export declare class DialogAdapter extends BaseAdapter<IDialogComponent> implements IDialogAdapter {
    private _backdropElement;
    private _containerElement;
    private _surfaceElement;
    private _moveTargetElement;
    private _activeElement;
    constructor(component: IDialogComponent);
    initializeAccessibility(): void;
    setAnimating(animating: boolean): void;
    setVisibility(visible: boolean): void;
    attach(): void;
    detach(): void;
    registerTransitionEndHandler(handler: (evt: TransitionEvent) => void): void;
    deregisterTransitionEndHandler(handler: (evt: TransitionEvent) => void): void;
    setDocumentListener(type: string, listener: (evt: Event) => void): void;
    removeDocumentListener(type: string, listener: (evt: Event) => void): void;
    registerBackdropClickHandler(handler: (evt: CustomEvent) => void): void;
    deregisterBackdropClickHandler(handler: (evt: CustomEvent) => void): void;
    getOpenDialogs(selector: string): NodeListOf<HTMLElement>;
    setBodyAttribute(name: string, value: string): void;
    removeBodyAttribute(name: string): void;
    trySetInitialFocus(): void;
    isScrollable(): boolean;
    addRootClass(name: string): void;
    setFullscreen(value: boolean): void;
    setMoveable(value: boolean): void;
    tryLayoutRippleChildren(): void;
    setMoveTarget(selector: string): boolean;
    setMoveTargetHandler(type: string, listener: (evt: MouseEvent) => void): void;
    removeDragTargetHandler(type: string, listener: (evt: MouseEvent) => void): void;
    getSurfaceBounds(): DOMRect;
    setSurfacePosition(x: string | null, y: string | null, positionType: DialogPositionType): void;
    captureActiveElement(): void;
    tryRestoreActiveElement(): void;
}
